package com.zhongzheng.modules.exam.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.common.utils.ServletUtils;
import com.zhongzheng.modules.pay.domain.PayAisle;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.exam.bo.ExamPaperAddBo;
import com.zhongzheng.modules.exam.bo.ExamPaperQueryBo;
import com.zhongzheng.modules.exam.bo.ExamPaperEditBo;
import com.zhongzheng.modules.exam.domain.ExamPaper;
import com.zhongzheng.modules.exam.mapper.ExamPaperMapper;
import com.zhongzheng.modules.exam.vo.ExamPaperVo;
import com.zhongzheng.modules.exam.service.IExamPaperService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 试卷类型Service业务层处理
 *
 * @author ruoyi
 * @date 2021-10-18
 */
@Service
public class ExamPaperServiceImpl extends ServiceImpl<ExamPaperMapper, ExamPaper> implements IExamPaperService {

    @Override
    public ExamPaperVo queryById(Long paperId){
        ExamPaper db = this.baseMapper.selectById(paperId);
        return BeanUtil.toBean(db, ExamPaperVo.class);
    }

    @Override
    public List<ExamPaperVo> queryList(ExamPaperQueryBo bo) {
        LambdaQueryWrapper<ExamPaper> lqw = Wrappers.lambdaQuery();
        lqw.like(StrUtil.isNotBlank(bo.getPaperName()), ExamPaper::getPaperName, bo.getPaperName());
        lqw.in(bo.getStatus() != null, ExamPaper::getStatus, bo.getStatus());
        lqw.eq(StrUtil.isNotBlank(bo.getEncoder()), ExamPaper::getEncoder, bo.getEncoder());
        lqw.orderByDesc(ExamPaper::getUpdateTime);
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<ExamPaperVo> entity2Vo(Collection<ExamPaper> collection) {
        List<ExamPaperVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, ExamPaperVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<ExamPaper> page = (Page<ExamPaper>)collection;
            Page<ExamPaperVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(ExamPaperAddBo bo) {
        ExamPaper add = BeanUtil.toBean(bo, ExamPaper.class);
        validEntityBeforeSave(add);
        add.setEncoder(ServletUtils.getEncoded("SJ"));
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(ExamPaperEditBo bo) {
        ExamPaper update = BeanUtil.toBean(bo, ExamPaper.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(ExamPaper entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
